<template>
  <v-group>
    <v-rect :config="node.config.container" />
    <v-text :config="{text: node.name, ...node.config.title}" />
    <v-text
      :config="{text: String.fromCharCode(215), ...node.config.close}"
      @mousedown="$event.cancelBubble=true"
      @click="deleteNode({index: index, event: $event})"
    />
    <analyserWaveView :audioData="audioData" />
    <v-group :config="node.config.inputsOrigin()">
      <GraphicPort :port="port" v-for="(port, i) in node.inputs" :key="`out-${i}`" />
    </v-group>
    <v-group :config="node.config.outputsOrigin()">
      <GraphicPort :port="port" v-for="(port, i) in node.outputs" :key="`out-${i}`" />
    </v-group>
  </v-group>
</template>

<script lang="ts">
import GraphicPort from "@/components/elements/GraphicPort.vue"
import AnalyserFrequencyView from "@/components/elements/AnalyserFrequencyView.vue"
import { mapMutations } from 'vuex';
import { AnalyserWaveWrapper } from '@/lib/gui/wrappers/AnalyserWaveWrapper';
import AnalyserWaveView from '../elements/AnalyserWaveView.vue';

export default {
  name: "AnalyserWaveNode",
  components: { GraphicPort, AnalyserFrequencyView, AnalyserWaveView },
  props: {
    index: Number,
    node: AnalyserWaveWrapper
  },
  methods: {
    ...mapMutations([
      "deleteNode",
    ]),
  },
  data: () => ({
    audioData: new Uint8Array(),
  }),
  mounted() {
    let rafId: number;
    const tick = () => {
      const dataArray: Uint8Array = new Uint8Array((this as any).node.node.frequencyBinCount);
      (this as any).node.node.getByteTimeDomainData(dataArray);
      (this as any).audioData = dataArray;
      rafId = requestAnimationFrame(tick);
    };
    rafId = requestAnimationFrame(tick);
  }
}
</script>
